"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_codegen_visitor_plugin_common_1 = require("graphql-codegen-visitor-plugin-common");
var graphql_1 = require("graphql");
var FlowSelectionSetToObject = /** @class */ (function (_super) {
    __extends(FlowSelectionSetToObject, _super);
    function FlowSelectionSetToObject(_scalars, _schema, _convertName, _addTypename, _visitorConfig, _parentSchemaType, _selectionSet) {
        var _this = _super.call(this, _scalars, _schema, _convertName, _addTypename, _parentSchemaType, _selectionSet) || this;
        _this._visitorConfig = _visitorConfig;
        return _this;
    }
    FlowSelectionSetToObject.prototype.createNext = function (parentSchemaType, selectionSet) {
        return new FlowSelectionSetToObject(this._scalars, this._schema, this._convertName, this._addTypename, this._visitorConfig, parentSchemaType, selectionSet);
    };
    FlowSelectionSetToObject.prototype.buildPrimitiveFields = function (parentName, fields) {
        if (fields.length === 0) {
            return null;
        }
        var useFlowExactObject = this._visitorConfig.useFlowExactObjects;
        var useFlowReadOnlyTypes = this._visitorConfig.useFlowReadOnlyTypes;
        return "$Pick<" + parentName + ", {" + (useFlowExactObject ? '|' : '') + " " + fields
            .map(function (fieldName) { return "" + (useFlowReadOnlyTypes ? '+' : '') + fieldName + ": *"; })
            .join(', ') + " " + (useFlowExactObject ? '|' : '') + "}>";
    };
    FlowSelectionSetToObject.prototype.buildLinkFields = function (fields) {
        if (fields.length === 0) {
            return null;
        }
        var useFlowExactObject = this._visitorConfig.useFlowExactObjects;
        var useFlowReadOnlyTypes = this._visitorConfig.useFlowReadOnlyTypes;
        return "{" + (useFlowExactObject ? '|' : '') + " " + fields
            .map(function (field) { return "" + (useFlowReadOnlyTypes ? '+' : '') + (field.alias || field.name) + ": " + field.selectionSet; })
            .join(', ') + " " + (useFlowExactObject ? '|' : '') + "}";
    };
    FlowSelectionSetToObject.prototype.buildAliasedPrimitiveFields = function (parentName, fields) {
        if (fields.length === 0) {
            return null;
        }
        var useFlowExactObject = this._visitorConfig.useFlowExactObjects;
        var useFlowReadOnlyTypes = this._visitorConfig.useFlowReadOnlyTypes;
        return "{" + (useFlowExactObject ? '|' : '') + " " + fields
            .map(function (aliasedField) {
            return "" + (useFlowReadOnlyTypes ? '+' : '') + aliasedField.alias + ": $ElementType<" + parentName + ", '" + aliasedField.fieldName + "'>";
        })
            .join(', ') + " " + (useFlowExactObject ? '|' : '') + "}";
    };
    FlowSelectionSetToObject.prototype.clearOptional = function (str) {
        if (str.startsWith('?')) {
            return str.substring(1);
        }
        return str;
    };
    FlowSelectionSetToObject.prototype.wrapTypeWithModifiers = function (baseType, type) {
        if (graphql_1.isNonNullType(type)) {
            return this.clearOptional(this.wrapTypeWithModifiers(baseType, type.ofType));
        }
        else if (graphql_1.isListType(type)) {
            var innerType = this.wrapTypeWithModifiers(baseType, type.ofType);
            return "?Array<" + innerType + ">";
        }
        else {
            return "?" + baseType;
        }
    };
    return FlowSelectionSetToObject;
}(graphql_codegen_visitor_plugin_common_1.SelectionSetToObject));
exports.FlowSelectionSetToObject = FlowSelectionSetToObject;
//# sourceMappingURL=flow-selection-set-to-object.js.map